﻿using Abp.Application.Services;
using Abp.Application.Services.Dto;
using Abp.Collections.Extensions;
using Abp.Domain.Repositories;
using MineTec.ProManager.FigureNumber.Dto;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace MineTec.ProManager.FigureNumber
{
    public class FigureNumberAppService : AsyncCrudAppService<Entitys.Graphic.FigureNumber.FigureNumber, FigureNumberDto, Guid, PagedResultRequestDto,
                            CreateUpdateFigureNumberDto, CreateUpdateFigureNumberDto>, IFigureNumberAppService

    {
        private readonly IRepository<Entitys.Graphic.FigureNumber.FigureNumber, Guid> _FigureNumberRepository;

        public FigureNumberAppService(IRepository<Entitys.Graphic.FigureNumber.FigureNumber, Guid> repository, IRepository<Entitys.Graphic.FigureNumber.FigureNumber, Guid> FigureNumberRepository)
            : base(repository)
        {
            _FigureNumberRepository = FigureNumberRepository;
        }

        public override Task<FigureNumberDto> CreateAsync(CreateUpdateFigureNumberDto input)
        {
            return base.CreateAsync(input);
        }

        public async Task<FigureNumberOutPut> GetAllFigureNumber(GetAllFigureNumber input)
        {

            var result = new FigureNumberOutPut();
            try
            {
                var query = base.CreateFilteredQuery(input).Where(t => t.IsDelete != 1).WhereIf(!string.IsNullOrEmpty(input.FigureNum), t => t.FigureNum.Contains(input.FigureNum)).WhereIf(!string.IsNullOrEmpty(input.Remark), t => t.Remark.Contains(input.Remark));
                var figurenumcount = query.Count();
                var figurenumlist = query.ToList();
                var list = ObjectMapper.Map<List<FigureNumberDto>>(figurenumlist);
                result.code = 0;
                result.count = figurenumcount;
                result.data = list;

            }
            catch (Exception ex)
            {
                result.msg = ex.Message;
            }

            return result;
        }

    }
}