﻿using Abp.Application.Services;
using Abp.Application.Services.Dto;
using Abp.Collections.Extensions;
using Abp.Domain.Repositories;
using MineTec.ProManager.MaterialNumber.Dto;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace MineTec.ProManager.MaterialNumber
{
    public class MaterialNumberAppService : AsyncCrudAppService<Entitys.Graphic.MaterialNumber.MaterialNumber, MaterialNumberDto, Guid, PagedResultRequestDto,
                        MaterialNumberDto, MaterialNumberDto>, IMaterialNumberAppService
    {
        public MaterialNumberAppService(IRepository<Entitys.Graphic.MaterialNumber.MaterialNumber, Guid> repository) : base(repository)
        {

        }

        public override Task<MaterialNumberDto> CreateAsync(MaterialNumberDto input)
        {
            return base.CreateAsync(input);
        }

        public async Task<MaterialNumberOutput> GetAllFigureNumber(GetAllMaterialNumber input)
        {

            var result = new MaterialNumberOutput();
            try
            {
                var query = base.CreateFilteredQuery(input).Where(t => t.IsDelete != 1).WhereIf(!string.IsNullOrEmpty(input.MaterialNum), t => t.MaterialNum.Contains(input.MaterialNum)).WhereIf(!string.IsNullOrEmpty(input.Remark), t => t.Remark.Contains(input.Remark));
                var materialnumcount = query.Count();
                var materialnumlist = query.ToList();
                var list = ObjectMapper.Map<List<MaterialNumberDto>>(materialnumlist);
                result.code = 0;
                result.count = materialnumcount;
                result.data = list;

            }
            catch (Exception ex)
            {
                result.msg = ex.Message;
            }

            return result;
        }
    }
}
