﻿using Abp.Application.Services;
using Abp.Application.Services.Dto;
using Abp.Collections.Extensions;
using Abp.Domain.Repositories;
using MineTec.ProManager.ProductNumber.Dto;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace MineTec.ProManager.ProductNumber
{
    public class ProductNumberAppService : AsyncCrudAppService<Entitys.Graphic.ProductNumber.ProductNumber, ProductNumberDto, Guid, PagedResultRequestDto,
                        ProductNumberDto, ProductNumberDto>, IProductNumberAppService
    {

        public ProductNumberAppService(IRepository<Entitys.Graphic.ProductNumber.ProductNumber, Guid> repository)
                    : base(repository)
        {

        }

        public override Task<ProductNumberDto> CreateAsync(ProductNumberDto input)
        {
            return base.CreateAsync(input);
        }

        public async Task<ProductNumberOutput> GetAllFigureNumber(GetAllProductNumber input)
        {

            var result = new ProductNumberOutput();
            try
            {
                var query = base.CreateFilteredQuery(input).Where(t => t.IsDelete != 1).WhereIf(!string.IsNullOrEmpty(input.ProductNum), t => t.ProductNum.Contains(input.ProductNum)).WhereIf(!string.IsNullOrEmpty(input.Remark), t => t.Remark.Contains(input.Remark));
                var productnumcount = query.Count();
                var productnumlist = query.ToList();
                var list = ObjectMapper.Map<List<ProductNumberDto>>(productnumlist);
                result.code = 0;
                result.count = productnumcount;
                result.data = list;

            }
            catch (Exception ex)
            {
                result.msg = ex.Message;
            }

            return result;
        }
    }
}
